""" Evolve to version 7.1
"""
allowed = set([
    '10 messages for 2010',
    '2010 biodiversity target',
    'aarhus convention',
    'abouteea',
    'absorption capacity',
    'abstraction',
    'accident',
    'acid',
    'acid rain',
    'acidification',
    'acidophilous oak forest',
    'adaptation',
    'adaptation strategy',
    'administrative',
    'advertising',
    'afforestation',
    'age',
    'aggregate extraction',
    'agri-environment',
    'agri-environment indicators',
    'agricultural ecosystem',
    'agriculture',
    'agriculture bioenergy potential',
    'agriculture policy',
    'agro-ecosystems',
    'air',
    'air conditioning',
    'air emissions',
    'air pollutant emissions',
    'air pollutant emissions data viewer',
    'air pollutant inventory',
    'air pollution',
    'air pollution control',
    'air pollution costs',
    'air pollution from energy',
    'air quality',
    'air quality data',
    'air quality directive',
    'air quality forecasting',
    'air quality monitoring',
    'air quality zones 2009',
    'air traffic',
    'air transport',
    'air transport emissions',
    'airbase',
    'alcohol',
    'algae',
    'alien species',
    'alkalinity',
    'allergy',
    'alpine',
    'alpine coniferous forest',
    'alpine rivers',
    'alps',
    'alps2009',
    'alternative fuel',
    'alternative water supplies',
    'altimetry',
    'aluminium',
    'ammonia',
    'ammonium',
    'amphibia',
    'amphibian',
    'an assessment of assessments',
    'anatolian',
    'anchovy',
    'ancillary data',
    'animal',
    'annual accounts',
    'annual average',
    'annual fellings',
    'annual management plan',
    'annual report',
    'anoxia',
    'anoxic',
    'anoxic area',
    'anthropogenic',
    'anthropogenic ghg emission',
    'antibiotic',
    'antifouling paint',
    'aot40',
    'ape',
    'ape001',
    'ape002',
    'ape003',
    'ape004',
    'ape005',
    'ape006',
    'ape2009',
    'ape2010',
    'ape2011',
    'ape3a',
    'appliances',
    'apr2007',
    'aquaculture',
    'aquatic ecosystems',
    'aquatic habitats',
    'aquatic life',
    'arctic',
    'arctic region',
    'arctic sea ice',
    'arsenic',
    'artificial sprawl',
    'artificialisation',
    'asbestos',
    'aspen forest',
    'assessment of assessments',
    'assessment04',
    'assessment05',
    'assessment06',
    'assessment07',
    'assessment08',
    'assessment09',
    'assessment10',
    'assessment11',
    'assessmentv2',
    'astana2011',
    'asthma',
    'atlantic',
    'atmosphere',
    'atmospheric nitrogen',
    'atmospheric pollutants',
    'august2009delivery',
    'automobile manufacturer',
    'avalanche',
    'avalanches',
    'aviation',
    'bactericide',
    'baltic',
    'baltic sea',
    'baltic sea ecosystem',
    'baltic sea ice',
    'baltic sea salinity',
    'baseline',
    'baseline2010',
    'bathing water',
    'bathing water directive',
    'bathing water quality',
    'bathing water report',
    'bdiv',
    'bdiv07d',
    'beach',
    'beach pollution',
    'beach water',
    'bear',
    'beech forest',
    'bees',
    'begining of environmental policy',
    'belgrade conference',
    'belgrade07',
    'benzene',
    'benzo(a)pyrene',
    'bicycle',
    'bicycle lane',
    'bicycle traffic',
    'bike',
    'bio-geographical regions',
    'biocapacity',
    'biodegradable waste',
    'biodiesel',
    'biodiversity',
    'biodiversity components',
    'biodiversity conservation',
    'biodiversity indicators',
    'biodiversity information system for europe',
    'biodiversity loss',
    'biodiversity monitoring',
    'biodynamic agriculture',
    'bioenergy',
    'bioenergy crops',
    'bioethanol',
    'biofuel',
    'biofuel directive',
    'biofules',
    'biogas',
    'biogeographic',
    'biogeographical region',
    'biological sequences',
    'biomass',
    'biomass action plan',
    'biomass combustion',
    'biomass energy',
    'biome',
    'biomes',
    'bioplant',
    'biotechnology',
    'biotope',
    'biowaste',
    'birch forest',
    'bird',
    'birds',
    'birds directive',
    'bise',
    'bison',
    'black sea',
    'black triangle',
    'black-tailed godwit',
    'blossom',
    'blue fish',
    'bod',
    'bod5',
    'bod7',
    'bog',
    'bonito',
    'boreal',
    'boreal forest',
    'bottled water',
    'brackish water',
    'broadleaved evergreen forest',
    'broadleaved-coniferous forest',
    'budget',
    'buildings',
    'bunker fuels',
    'burden-sharing',
    'burning waste',
    'bus',
    'butterfly',
    'cabon binding',
    'cadmium',
    'cafe',
    'cancer',
    'candidate countries',
    'cap',
    'cap and trade',
    'capacity building',
    'capita',
    'car',
    'car industry',
    'car occupancy',
    'car ownership',
    'car sales',
    'car sharing',
    'carbon',
    'carbon capture',
    'carbon capture technology',
    'carbon cycle',
    'carbon dioxide',
    'carbon efficiency',
    'carbon emission',
    'carbon footprint',
    'carbon monoxide',
    'carbon sink',
    'carbon stock',
    'carbon storage',
    'carbon uptake',
    'cardboard',
    'cardboard recycling',
    'cardiovascular',
    'cardiovascular disease',
    'caretta caretta turtle',
    'carpool',
    'cars',
    'carsharing',
    'case studies',
    'caspian sea',
    'catchment',
    'cattle',
    'caucasus',
    'cba',
    'ccpm',
    'ccs',
    'cd',
    'cdda',
    'central asia',
    'central heating',
    'central park',
    'cepa',
    'cereal',
    'certification',
    'certified emission reduction',
    'cfc',
    'cfl',
    'cfp',
    'ch4',
    'change',
    'chemical',
    'chemical concentration model',
    'chemical density',
    'chemical elements',
    'chemical industry',
    'chemical policy',
    'chemical pollution',
    'chemical product labelling',
    'chemicals',
    'chemicals information system',
    'childhood cancer',
    'chlorophyll-a',
    'chp',
    'circles of discovery',
    'cities',
    'citizen science',
    'citl',
    'city',
    'citybees',
    'civitas',
    'classification',
    'clc',
    'clc technical guidelines',
    'clc1990',
    'clc2000',
    'clc2006',
    'clcchanges',
    'clean water',
    'clim',
    'clim001',
    'clim002',
    'clim003',
    'clim004',
    'clim005',
    'clim006',
    'clim007',
    'clim008',
    'clim009',
    'clim010',
    'clim011',
    'clim012',
    'clim013',
    'clim014',
    'clim015',
    'clim016',
    'clim017',
    'clim018',
    'clim019',
    'clim020',
    'clim021',
    'clim022',
    'clim023',
    'clim024',
    'clim025',
    'clim026',
    'clim027',
    'clim028',
    'clim029',
    'clim030',
    'clim031',
    'clim032',
    'clim033',
    'clim034',
    'clim035',
    'clim036',
    'clim037',
    'clim038',
    'clim039',
    'clim040',
    'clim041',
    'clim042',
    'clim08',
    'clim2008',
    'climate',
    'climate action network',
    'climate change',
    'climate change adaptation',
    'climate change adaption',
    'climate change and health',
    'climate change and you (en)',
    'climate change consequences',
    'climate change impacts',
    'climate change in mountains',
    'climate change mitigation',
    'climate strategy',
    'climatic change',
    'clrtap',
    'co',
    'co2',
    'co2 credit',
    'co2 emissions',
    'co2 leakage',
    'co2 transferral',
    'coach',
    'coal',
    'coast',
    'coast_sea',
    'coastal',
    'coastal areas',
    'coastal bathing waters',
    'coastal city',
    'coastal ecosystem',
    'coastal erosion',
    'coastal management',
    'coastal sediment balance',
    'coastal water',
    'coastal waters',
    'coastline urbanisation',
    'coasts',
    'cod',
    'code list',
    'coffee',
    'combined heat and power',
    'combustion',
    'combustion plant',
    'common agricultural policy',
    'common bird',
    'common fisheries policy',
    'common transport policy',
    'community farm',
    'compact fluorescent lamp',
    'compaction',
    'competition for resources',
    'composting',
    'compounds',
    'concentration',
    'conductivity',
    'congestion charge',
    'conifer',
    'coniferous forest',
    'conservation',
    'conservation of biodiversity',
    'conservation of species',
    'construction',
    'construction mineral',
    'consumer behaviour',
    'consumer good',
    'consumer prices',
    'consumption',
    'consumption and production patterns',
    'consumption pattern',
    'consumption patterns',
    'consumption trend',
    'container',
    'contaminated land',
    'contaminated soil',
    'contamination',
    'continental',
    'contributing factors',
    'conversion',
    'cooling',
    'cop15',
    'copper',
    'coral acidification',
    'coral reefs',
    'corilis',
    'corinair',
    'corine',
    'corine land cover',
    'cork',
    'corporate communication',
    'corrosion',
    'cost-benefit analysis',
    'costs of adaptation',
    'costs of inaction',
    'country codes',
    'country policy',
    'cover',
    'crop',
    'crop yield',
    'cropland',
    'crops',
    'cross-sectoral adaptation',
    'cryosphere',
    'crysopteris montana',
    'csi',
    'csi001',
    'csi002',
    'csi003',
    'csi004',
    'csi005',
    'csi006',
    'csi007',
    'csi008',
    'csi009',
    'csi010',
    'csi011',
    'csi012',
    'csi013',
    'csi014',
    'csi015',
    'csi016',
    'csi017',
    'csi018',
    'csi019',
    'csi020',
    'csi021',
    'csi022',
    'csi023',
    'csi024',
    'csi025',
    'csi026',
    'csi027',
    'csi028',
    'csi029',
    'csi030',
    'csi031',
    'csi032',
    'csi033',
    'csi034',
    'csi035',
    'csi036',
    'csi037',
    'csi0xx',
    'cultural landscapes',
    'cycle',
    'dam',
    'danube',
    'data centre',
    'data flow',
    'data management',
    'ddt',
    'deadwood',
    'death',
    'decision-making',
    'decomposition',
    'decomposition analysis',
    'decouple',
    'decoupling',
    'deepwater',
    'defoliation',
    'deforestation',
    'degradation',
    'dem',
    'demand',
    'demography',
    'demolition',
    'density',
    'deposition',
    'desalination',
    'desert',
    'desertification',
    'designated areas',
    'determinand',
    'developed countries',
    'developing countries',
    'development',
    'development of gdp',
    'development of prices',
    'diesel',
    'diet',
    'dietary',
    'diffuse',
    'diffuse contamination',
    'diffuse sources',
    'dike',
    'dioxin',
    'dioxins and furans',
    'direct and indirect pressures',
    'directive',
    'disaster',
    'discharge',
    'disease',
    'diseases',
    'dismed',
    'displacements',
    'display',
    'disposal',
    'distribution',
    'distribution of species',
    'distribution of waste',
    'dmc',
    'dmc per capita',
    'domestic animals',
    'domestic appliance',
    'domestic material consumption',
    'dominant landscapes types',
    'dpsir',
    'drinking water',
    'drivers of change',
    'driving tips',
    'drought',
    'droughts',
    'dry matter',
    'dust mites',
    'e-prtr',
    'e-waste',
    'early warning',
    'earth summit',
    'earthquake',
    'eastern europe',
    'eco-industry',
    'eco-label',
    'eco-technology',
    'eco-village',
    'ecodesign',
    'ecodrive',
    'ecodriving',
    'ecolabel',
    'ecological diversity',
    'ecological footprint',
    'ecological network',
    'ecology',
    'economic',
    'economic assessment',
    'economic competitiveness',
    'economic damage costs',
    'economic downturn',
    'economic growth',
    'economic megatrends',
    'economic policy instruments',
    'economic unequality',
    'economy',
    'ecosoc',
    'ecosystem',
    'ecosystem accounting',
    'ecosystem integrity',
    'ecosystem resilience',
    'ecosystem services',
    'ecosystems',
    'ecosystems perspective',
    'ecotourism',
    'education',
    'education based travel',
    'ee-aoa',
    'ee_f01',
    'ee_f02',
    'ee_f04',
    'ee_f05',
    'ee_f06',
    'ee_f07',
    'ee_f08',
    'ee_f09',
    'ee_f11',
    'ee_f12',
    'ee_f13',
    'eea',
    'eea environment policy',
    'eea general brochure 2009 (bg)',
    'eea member countries',
    'eea owned data sets',
    'eea product',
    'eea report no 2/2004',
    'eea role',
    'eea signals 2010 - biodiversity',
    'eea strategy',
    'eea target audience',
    'eetap',
    'efficiency',
    'eionet',
    'eionet waterbase',
    'eionet-water',
    'electric car',
    'electricity',
    'electricity consumption',
    'electricity generation',
    'electromagnetic field',
    'electronic equipment',
    'electronic waste',
    'elevation',
    'emas',
    'emep',
    'emep model scenarios',
    'emf',
    'emission',
    'emission ceiling',
    'emission inventory',
    'emission monitoring',
    'emission offsetting',
    'emission reduction',
    'emission reduction unit',
    'emission trading',
    'emission trading scheme',
    'emission trends',
    'emission trends and projections',
    'emission unit',
    'emissions',
    'emissions for industry',
    'emissions from agriculture',
    'emissions from transport',
    'emissions reduction',
    'emissions trading directive',
    'emissions trading scheme',
    'emissions trading system',
    'emissions trends and projections',
    'employment',
    'endangered plant species',
    'endangered species',
    'endemic species',
    'endenism',
    'endocrine disruption',
    'ener',
    'ener001',
    'ener005',
    'ener006',
    'ener007',
    'ener007ener2011',
    'ener008',
    'ener009',
    'ener01',
    'ener010',
    'ener011',
    'ener012',
    'ener013',
    'ener014',
    'ener015',
    'ener016',
    'ener017',
    'ener018',
    'ener019',
    'ener02',
    'ener020',
    'ener021',
    'ener022',
    'ener023',
    'ener024',
    'ener025',
    'ener026',
    'ener027',
    'ener028',
    'ener029',
    'ener030',
    'ener031',
    'ener032',
    'ener034',
    'ener035',
    'ener05',
    'ener06',
    'ener07',
    'ener08',
    'ener09',
    'ener11',
    'ener12',
    'ener13',
    'ener15',
    'ener16',
    'ener17',
    'ener18',
    'ener19',
    'ener20',
    'ener2009',
    'ener2010',
    'ener2011',
    'ener21',
    'ener22',
    'ener23',
    'ener24',
    'ener25',
    'ener26',
    'ener27',
    'ener28',
    'ener29',
    'ener30',
    'ener31',
    'ener32',
    'ener34',
    'ener35',
    'energy',
    'energy audit',
    'energy certification',
    'energy consumption',
    'energy consumtion',
    'energy crisis',
    'energy demand',
    'energy efficiency',
    'energy efficiency label',
    'energy efficient buildings',
    'energy efficient bulb',
    'energy efficient lighting',
    'energy intensity',
    'energy mix',
    'energy policy',
    'energy price',
    'energy production',
    'energy production emissions',
    'energy production impact',
    'energy productivity',
    'energy use',
    'energy-related emission',
    'energy2008',
    'enpi-seis',
    'enquiries',
    'enteric fermentation',
    'environment',
    'environment for europe',
    'environmental',
    'environmental accounts',
    'environmental agreements',
    'environmental assessment report no 10',
    'environmental assets',
    'environmental change model',
    'environmental charges',
    'environmental footprint',
    'environmental information system',
    'environmental law',
    'environmental management system',
    'environmental megatrends',
    'environmental model characterisation',
    'environmental model inventory',
    'environmental modelling technique',
    'environmental policy',
    'environmental politics',
    'environmental pressure',
    'environmental pressure intensity',
    'environmental statement',
    'environmental tax reform',
    'environmental taxes',
    'environmental technology industry',
    'environmental trends',
    'environmental zone',
    'environmentally-compatible bioenergy',
    'environmentally-oriented farming',
    'eof',
    'eoid',
    'eper',
    'erosion',
    'eru',
    'estuary',
    'etc/acc',
    'etc/npb',
    'etc/wtr',
    'etr',
    'ets',
    'eu',
    'eu 2020',
    'eu air emission policies',
    'eu cohesion policy',
    'eu coverage',
    'eu emission inventory',
    'eu ets',
    'eu ghg inventory',
    'eu legislation',
    'eu marine strategy framework directive',
    'eu objective',
    'eu policies',
    'eu strategy',
    'eu waste types',
    'eu-15',
    'eu-27',
    'eunis',
    'euroharp',
    'europa',
    'europe',
    "europe's environment",
    'european adaptation strategy',
    'european environment',
    'european free trade association (efta)',
    'european neighbourhood',
    'european neighbourhood project',
    'european union (eu)',
    'eurosion',
    'eurowaternet',
    'eutrophication',
    'evaporation',
    'exceedance',
    'exchange of information decision',
    'exhaust gas',
    'exotic species',
    'expansion',
    'expenditure',
    'export',
    'exports',
    'exposure',
    'extensive farming',
    'externalities',
    'extinction',
    'extraction',
    'extreme events',
    'extreme temperatures',
    'extreme weather event',
    'eye on earth',
    'facebook',
    'fact sheets',
    'fairmode',
    'fame',
    'farm',
    'farming',
    'farmland',
    'farmland abandonment',
    'farmland biodiversity',
    'fatty acid methyl ether',
    'felling',
    'fertiliser',
    'fertility',
    'fertilization',
    'financial crisis',
    'financing',
    'fine dust',
    'fine particles',
    'finland',
    'fire',
    'first environmental policies',
    'fiscal reform',
    'fish',
    'fish catch',
    'fish stock',
    'fish003',
    'fish004',
    'fish005',
    'fish011',
    'fish01a',
    'fish01b',
    'fisheries',
    'fishery',
    'fishing',
    'flame-retardant',
    'flis',
    'floating house',
    'flood',
    'flood defence',
    'flood management',
    'flooding',
    'floodplain forest',
    'floods',
    'flora',
    'flowering',
    'fluorinated gases',
    'food',
    'food consumption',
    'food consumption patterns',
    'food processing',
    'food production',
    'food production and consumption',
    'food transport',
    'forest',
    'forest biodiversity',
    'forest connectivity',
    'forest conservation',
    'forest creation',
    'forest degradation',
    'forest disturbance',
    'forest ecosystem',
    'forest fires',
    'forest management',
    'forest monitoring',
    'forest stewardship council',
    'forest thinning',
    'forest type',
    'forest2008',
    'forestry',
    'forestry bioenergy potential',
    'forestry model',
    'forests',
    'formation',
    'forward-looking indicator',
    'forward-looking information and services',
    'fossil',
    'fossil fuel',
    'fossil fuels',
    'fragmentation',
    'fragmentation report 2011',
    'freight',
    'freight activity',
    'freight transport',
    'freight transport intensity',
    'freshwater',
    'freshwater abstraction',
    'freshwater ecosystems',
    'freshwater pollution',
    'freshwater quality',
    'fridge',
    'frost',
    'fruit',
    'fuel',
    'fuel cell',
    'fuel consumption',
    'fuel efficiency',
    'fuel price',
    'fuel switch',
    'fungicide',
    'furan',
    'future environmental challenges',
    'future priorities',
    'garbage',
    'gas',
    'gas exploitation',
    'gdp',
    'gender',
    'genes',
    'genetic diversity',
    'genetic pollution',
    'genetically modified organism',
    'geographic',
    'geology',
    'geophysical hazards',
    'geospatial data',
    'ghg',
    'ghg emission',
    'ghg emission trend',
    'ghg emissions',
    'ghg inventory',
    'ghg inventory reporting',
    'ghg retrospective',
    'ghg2008',
    'ghg2009',
    'ghg2009-2.1',
    'ghg2010',
    'ghg2011',
    'gis',
    'gisco',
    'glacier',
    'glaciers',
    'glass waste',
    'global',
    'global consumption',
    'global governance',
    'global impacts',
    'global megatrends',
    'global monitoring for environment and security',
    'global resource exploitation',
    'global trade',
    'global warming',
    'globalisation',
    'gmes',
    'gmos',
    'gothenburg protocol',
    'governance',
    'gps',
    'grains',
    'grassland',
    'gravel',
    'gravel extraction',
    'green architecture',
    'green area',
    'green budget',
    'green economy',
    'green growth',
    'green job',
    'green pharmacy',
    'green purchasing',
    'green space',
    'green tax',
    'green technology',
    'green tip',
    'green urban areas',
    'green wall',
    'green week',
    'greenhouse gas',
    'greenhouse gas emission',
    'greenhouse gas emissions',
    'greenhouse gas inventory',
    'greenhouse gases',
    'greenland',
    'greens',
    'greenx',
    'grid',
    'ground-level ozone',
    'groundwater',
    'groundwater quality',
    'growing season',
    'growth rates',
    'gua',
    'guidelines',
    'guidelines on monitoring and reporting',
    'habitat',
    'habitat destruction',
    'habitat directive',
    'habitat fragmentation',
    'habitats',
    'habitats directive',
    'halocarbons',
    'harmful algal bloom',
    'hazardous chemical',
    'hazardous substance',
    'hazardous waste',
    'hazards',
    'hcb',
    'hch',
    'health',
    'health effects',
    'health impact',
    'health target value',
    'heat',
    'heat wave',
    'heath and scrub',
    'heating',
    'heating degree',
    'heavy metal',
    'heavy metals',
    'help',
    'hemiboreal forest',
    'hemisphere',
    'herbicide',
    'hexachlorobenzene',
    'hexachlorocyclohexane',
    'hfc',
    'hg',
    'hidden costs of production',
    'high emitting households',
    'high nature value',
    'high ozone concentration',
    'high-input farming',
    'hnv',
    'household',
    'household consumption',
    'household energy consumption',
    'household waste',
    'housing',
    'human',
    'human health',
    'hunting',
    'hybrid vehicle',
    'hydrocarbons',
    'hydroelectric dam',
    'hydrological cycle',
    'hydrometeorological hazards',
    'hydropower',
    'hypoxic',
    'iberian lynx',
    'ice',
    'ice cover',
    'ice extend',
    'ice melting',
    'ice road',
    'iczm',
    'ied',
    'illegal',
    'illegal waste shipment',
    'image2000',
    'immigration',
    'impact',
    'impacts',
    'import',
    'import dependency',
    'imports',
    'in-shore',
    'incineration',
    'income',
    'increment',
    'indicator',
    'indigenous people',
    'indoor pollution',
    'industrial',
    'industrial accident',
    'industrial combustion',
    'industrial effluent',
    'industrial emissions directive',
    'industrial facility',
    'industrial processes',
    'industrial production',
    'industrial waste',
    'industrialisation',
    'industry',
    'information technologies',
    'infrastructure',
    'inland',
    'inland bathing water',
    'inland water',
    'innovation',
    'insect',
    'insecticide',
    'insulation',
    'integrated assessment',
    'integrated coastal management',
    'integrated farming',
    'integrated pollution prevention and control',
    'integrated urban management',
    'intelligent irrigation',
    'intensity',
    'intensive farming',
    'international statistical classifications',
    'invasive',
    'invasive alien species',
    'invasive species',
    'inventions',
    'inventories',
    'inventory',
    'inventory guidebook',
    'invertebrate',
    'ipcc',
    'ippc',
    'irena',
    'iron and steel waste',
    'irrigation',
    'italy',
    'jacqueline mcglade',
    'janez potocnik',
    'key pollutants',
    'killer slug',
    'kitchen and garden waste',
    'kulturnat',
    'kyoto',
    'kyoto gases',
    'kyoto mechanism',
    'kyoto protocol',
    'kyoto targets',
    'labour',
    'labour productivity',
    'lake',
    'lakes',
    'land',
    'land change',
    'land conservation',
    'land conversion',
    'land cover',
    'land cover change',
    'land cover flow',
    'land development',
    'land management',
    'land monitoring',
    'land prices',
    'land sink',
    'land take',
    'land use',
    'land use change',
    'land use changes',
    'land use planning',
    'land use trends',
    'landfill',
    'landfill directive',
    'landfilling',
    'landing',
    'landscape',
    'landscape changes',
    'landscape fragmentation',
    'landscape management',
    'landscape planning',
    'landscape protection area',
    'landslide',
    'landslides',
    'landuse',
    'lba',
    'lca',
    'lcep',
    'leac',
    'lead',
    'leafing',
    'legal instruments',
    'less favoured areas',
    'lfa',
    'liability and  compensation schemes',
    'life',
    'life cycle',
    'life cycle approach',
    'life cycle assessment',
    'life expectancy',
    'life-cycle thinking',
    'lighting',
    'lignite',
    'lindane',
    'literacy',
    'livestock',
    'living area',
    'lme',
    'load',
    'lobster',
    'local emissions',
    'local production',
    'log',
    'loggerhead turtle',
    'logging',
    'long-range transboundary air pollution',
    'long-term perspective',
    'lorry load factor',
    'loss of land',
    'low emitting households',
    'low level ozone',
    'low-carbon economy',
    'low-cost flight',
    'low-input farming',
    'lpg',
    'lrtap',
    'lrtap convention',
    'lubricant',
    'lucas data quality',
    'lulucf',
    'lung disease',
    'lutra lutra',
    'macaronesia',
    'mackeral',
    'malaria',
    'mammal',
    'management plan',
    'mandrake',
    'manufactured chemicals',
    'manure',
    'maps',
    'marine',
    'marine and coastal',
    'marine ecosystems',
    'marine gas field',
    'marine litter',
    'marine management',
    'marine oil field',
    'marine pollution',
    'marine resources conservation',
    'marine strategy framework directive',
    'marine transport',
    'marine trophic index',
    'marine water',
    'maritime',
    'maritime economy',
    'market-based instrument',
    'marshland',
    'massif',
    'massifs',
    'material flow analysis',
    'material flows',
    'material footprint',
    'material productivity',
    'material resources',
    'materials',
    'mbi',
    'measures',
    'meat',
    'median',
    'mediterranean',
    'megatrends',
    'mercury',
    'mesophytic deciduous forest',
    'metal',
    'metal production',
    'metals',
    'methane',
    'middle-class',
    'migration',
    'milk',
    'millenium seed bank',
    'mineral',
    'minerals',
    'mining',
    'mire and swamp forest',
    'mitigation',
    'mixtures and alloys.',
    'mobile phone',
    'mobile sources',
    'mobility',
    'mobility week',
    'modal split',
    'mode',
    'model',
    'mollusc',
    'monitor',
    'montreal protocol',
    'mortality',
    'moss',
    'mothers milk',
    'motorisation',
    'motorways',
    'mountain',
    'mountain area',
    'mountain ecosystem',
    'mountain flower',
    'mountain2010',
    'mountainous beech forest',
    'mountains',
    'msfd',
    'mudflat',
    'multinational emissions trading scheme',
    'municipal',
    'municipal solid waste',
    'municipal waste',
    'municipal waste generation',
    'muscle',
    'mussel',
    'n',
    'n2o',
    'namea',
    'nanotechnology',
    'nao index',
    'national adaptation strategy',
    'national emission ceilings directive',
    'national emissions ceilings',
    'national focal point',
    'national park',
    'national strategies',
    'native species',
    'natlan',
    'natura 2000',
    'natura 2000 sites',
    'natura2000',
    'natural',
    'natural areas protection',
    'natural capital',
    'natural compost',
    'natural disasters',
    'natural gas',
    'natural hazards',
    'natural heritage',
    'natural materials',
    'natural parc',
    'natural park',
    'natural resource conservation',
    'natural resources',
    'nature',
    'nature and biodiversity',
    'nature capital',
    'nature conservation',
    'nature reserve',
    'near real-time data',
    'nec',
    'nec directive',
    'necd',
    'negative impacts of bioenergy',
    'neigbourhood',
    'neighbourhood',
    'nemoral coniferous forest',
    'net annual increment',
    'network',
    'neurodevelopmental disorder',
    'ngo',
    'nh3',
    'nh4-n',
    'nickel',
    'nitrate',
    'nitrates directive',
    'nitrite',
    'nitrogen',
    'nitrogen balance',
    'nitrogen dioxide',
    'nitrogen oxide',
    'nitrogen oxides',
    'nitrous oxide',
    'nmvoc',
    'no2',
    'no3-n',
    'nocturnal species',
    'noise',
    'noise database',
    'noise exposure',
    'noise indicators',
    'noise reduction',
    'nomenclature',
    'nomenclature server',
    'non-governmental',
    'non-hazardous waste',
    'non-methane volatile organic compounds',
    'non-motorised transport',
    'non-renewable energy',
    'non-renewable resource',
    'non-riverine alder forest',
    'non-road transport',
    'non-state actors',
    'north sea',
    'notified waste',
    'nox',
    'nuclear',
    'nuclear accident',
    'nuclear plant',
    'nuclear safety',
    'nutrient',
    'nutrient enrichment',
    'nutrients',
    'nuts',
    'o3',
    'obsolete chemical',
    'ocean',
    'ocean acidification',
    'ocean acidity',
    'ocean sink',
    'ocean temperature',
    'odex',
    'oecd',
    'off-shore structure',
    'offshore',
    'offshore wind energy',
    'oi',
    'oi001',
    'oi003',
    'oi004',
    'oi005',
    'oi006',
    'oi008',
    'oi009',
    'oi011',
    'oi016',
    'oi018',
    'oi019',
    'oi022',
    'oi023',
    'oi025',
    'oi042',
    'oi045',
    'oi047',
    'oi054',
    'oi055',
    'oi0xx',
    'oil',
    'oil discharge',
    'oil exploitation',
    'oil price',
    'oil processing',
    'oil spill',
    'oil spills',
    'old-growth forest',
    'one',
    'onshore wind energy',
    'organic',
    'organic agriculture',
    'organic farming',
    'organic food',
    'organic micro-pollutant',
    'organic soils',
    'organic substances',
    'organophosphate',
    'orthophosphate',
    'otter',
    'our arctic challenge',
    'our natural europe',
    'outlook',
    'outlook indicator',
    'outlook002',
    'outlook003',
    'outlook004',
    'outlook005',
    'outlook006',
    'outlook007',
    'outlook008',
    'outlook009',
    'outlook010',
    'outlook011',
    'outlook013',
    'outlook014',
    'outlook017',
    'outlook018',
    'outlook019',
    'outlook020',
    'outlook021',
    'outlook023',
    'outlook024',
    'outlook025',
    'outlook026',
    'outlook027',
    'outlook028',
    'outlook030',
    'outlook031',
    'outlook032',
    'outlook035',
    'outlook036',
    'outlook037',
    'outlook039',
    'outlook041',
    'outlook042',
    'outlook043',
    'outlook046',
    'outlook047',
    'outlook048',
    'outlook049',
    'outlook05',
    'outlook050',
    'outlook051',
    'outlook052',
    'outlook053',
    'outlook054',
    'outlook055',
    'outlook056',
    'over-abstraction',
    'overcrowding',
    'overfishing',
    'oxidised',
    'oxy-fuel combustion',
    'oxygen',
    'oxygen depletion',
    'ozone',
    'ozone air pollution',
    'ozone depleting substance',
    'ozone depletion',
    'ozone health impacts',
    'ozone hole',
    'ozone layer',
    'ozone peak',
    'ozone precursors',
    'ozone station',
    'ozone vegetation impacts',
    'packaging waste',
    'pah',
    'pan-europe',
    'pan-european',
    'pan-european environment',
    'pandemics',
    'pannonian',
    'paper',
    'paper recycling',
    'paper waste',
    'paraben',
    'parking space',
    'particle emissions',
    'particulate matter',
    'passenger',
    'passenger car',
    'passenger transport',
    'passenger transport intensity',
    'passive house',
    'pasture',
    'patent',
    'patent genetic resources',
    'pathogenic micro-organism',
    'pb',
    'pbc',
    'pcb',
    'pcdd/f',
    'pcp',
    'pentachlorophenol',
    'permafrost',
    'persistent organic pollutants',
    'pesticide',
    'pesticides',
    'petrol',
    'petrol emission',
    'pfc',
    'ph',
    'phallates',
    'pharmaceuticals',
    'phenology',
    'phosphate',
    'phosphorus',
    'phthalates',
    'pipeline',
    'plane',
    'plankton',
    'plant',
    'plantation',
    'plastic',
    'plastic waste',
    'pm',
    'pm10',
    'pm10 health impacts',
    'pm2.5',
    'po',
    'point data',
    'point of pollution',
    'polar bears',
    'policies',
    'policy',
    'policy effectiveness evaluation',
    'policy instruments',
    'policy integration',
    'policy measures',
    'policy-making',
    'political megatrends',
    'pollen',
    'pollutant',
    'pollutants',
    'pollution',
    'polychlorinated biphenyls',
    'polycyclic aromatic hydrocarbons',
    'polymers',
    'pond',
    'pops',
    'population',
    'population change',
    'population density',
    'population exposure',
    'population trend',
    'pork',
    'posidonia oceanica',
    'post-socialist transition',
    'potash',
    'potato',
    'poverty',
    'power plant',
    'power shifts',
    'powerplant',
    'precautionary principle',
    'precious metal',
    'precipitation',
    'prelude',
    'pressure',
    'price',
    'price of water',
    'pricing policy',
    'product groups',
    'product use',
    'production',
    'production patterns',
    'productivity',
    'products',
    'projection',
    'protected area',
    'protected areas',
    'protected species',
    'protection',
    'protocols',
    'public awareness',
    'public health',
    'public opinion',
    'public outreach',
    'public service',
    'public space',
    'public transport',
    'public water supply',
    'publication',
    'pvc',
    'qol2009',
    'quality of life',
    'quarrrying',
    'radiation',
    'radioactivity',
    'radon',
    'rail',
    'railway',
    'rain',
    'rain water',
    'rainforest',
    'ramon',
    'ramsar',
    'ranunculus montanus',
    'rapeseed oil',
    'rare metal',
    'raster data',
    'raw material',
    'raw material consumption',
    'raw materials',
    'rbd',
    'reach',
    'recession',
    'recreational area',
    'recycled material',
    'recycling',
    'recycling of car',
    'red list',
    'redd',
    'reduction',
    'reforestation',
    'refugee',
    'regeneration',
    'regeneration of industrial area',
    'regions',
    'registration',
    'reindeer',
    'releases',
    'renewable',
    'renewable energy',
    'renewables',
    'reporting',
    'reporting obligations',
    'reptile',
    'research',
    'reserve',
    'residential',
    'residue',
    'resilience',
    'resource',
    'resource efficiency',
    'resource efficiency roadmap',
    'resource use',
    'resources',
    'respiratory diseases',
    'response',
    'rhine',
    'rhone',
    'rio conference',
    'risk',
    'risk management',
    'risk reduction',
    'river',
    'river basin district',
    'river basin management',
    'river navigation',
    'river system',
    'rivers',
    'road',
    'road capacity',
    'road density',
    'road freight',
    'road safety',
    'road traffic',
    'road transport',
    'rock',
    'rock extraction',
    'rockfalls',
    'rocky habitats',
    'rubbish',
    'rumex nivalis',
    'run-off',
    'rural',
    'safe biological limits',
    'safe water',
    'saline intrusion',
    'salinisation',
    'salmon',
    'salt-marsh',
    'sand',
    'sand erosion',
    'sand extraction',
    'sanitation',
    'satellite imagery',
    'satellite observations',
    'saturation',
    'sbl',
    'scenario studies',
    'scenarios',
    'scp',
    'scp2007',
    'se_f02',
    'sea',
    'sea catchment',
    'sea ice',
    'sea level',
    'sea level rise',
    'sea surface',
    'sea surface temperature',
    'sea temperature',
    'seabed habitat',
    'seabed mining',
    'seagrass',
    'seal',
    'sebi',
    'sebi001',
    'sebi002',
    'sebi003',
    'sebi004',
    'sebi005',
    'sebi006',
    'sebi007',
    'sebi008',
    'sebi009',
    'sebi01',
    'sebi010',
    'sebi011',
    'sebi012',
    'sebi013',
    'sebi015',
    'sebi016',
    'sebi017',
    'sebi018',
    'sebi019',
    'sebi02',
    'sebi020',
    'sebi021',
    'sebi022',
    'sebi023',
    'sebi024',
    'sebi025',
    'sebi026',
    'sebi03',
    'sebi04',
    'sebi05',
    'sebi06',
    'sebi07',
    'sebi08',
    'sebi09',
    'sebi10',
    'sebi11',
    'sebi12',
    'sebi13',
    'sebi15',
    'sebi16',
    'sebi17',
    'sebi18',
    'sebi19',
    'sebi20',
    'sebi2009',
    'sebi2010',
    'sebi22',
    'sebi23',
    'sebi24',
    'sebi25',
    'sebi26',
    'sebiassessment09',
    'second generation biofuels',
    'sector',
    'sectoral integration',
    'sectors',
    'security',
    'security of energy supply',
    'sediment',
    'seed bank',
    'seis',
    'seismic',
    'self-sown exotic forest',
    'semi-natural habitat',
    'service',
    'settlement',
    'sewage',
    'sewage treatment',
    'sewer',
    'sewerage',
    'sewerage network',
    'sf6',
    'shared environmental information system',
    'sheep',
    'shipment',
    'shipping',
    'shopping journey',
    'shrimp',
    'signals 2010',
    'signals2009',
    'signals2011',
    'simulation-based model',
    'sip',
    'site',
    'ski resort',
    'skin cancer',
    'smog',
    'smoking',
    'snow cover',
    'snowline',
    'so2',
    'social equity',
    'social inequalities',
    'social media',
    'social megatrends',
    'socio-economy',
    'soer',
    'soer2010',
    'soil',
    'soil conservation',
    'soil country profiles - population density',
    'soil functions',
    'soil moisture',
    'soil organic matter',
    'soil protection',
    'soil sealing',
    'solar energy',
    'solid fuels',
    'solvent',
    'somo35',
    'sorting waste',
    'sources',
    'sox',
    'spa',
    'space heating',
    'spatial analysis',
    'spatial data',
    'spatial planning',
    'special protection area',
    'species',
    'species impoverishment',
    'species richness',
    'specific regions',
    'speed limits',
    'sprat',
    'sprawl',
    'standard',
    'state',
    'state and outlook 2005',
    'state and outlook 2005 - part a',
    'state and outlook 2005 - part b',
    'state and outlook 2005 - part c',
    'state of the environment',
    'state of the environment report 1-2007',
    'station',
    'statistical regions',
    'statistics',
    'status and trends',
    'stavros dimas',
    'steel',
    'steppic',
    'storm',
    'storm overflow',
    'storms',
    'strategy analysis',
    'stratified catchment assessment',
    'street',
    'street increment',
    'street lamp',
    'streetlight',
    'subsidies',
    'subsidy',
    'suburbs',
    'sulfur dioxide',
    'sulfur hexafluoride',
    'sulphate',
    'sulphur',
    'sulphur dioxide',
    'sulphur oxides',
    'summer',
    'summer ice',
    'summer ozone episode',
    'summerhouses',
    'sunlight',
    'support scheme',
    'surface temperature',
    'surface water',
    'sustainability',
    'sustainable',
    'sustainable consumption',
    'sustainable consumption and production',
    'sustainable development',
    'sustainable energy production',
    'sustainable farming',
    'sustainable food consumption',
    'sustainable forest management',
    'sustainable forestry',
    'sustainable housing',
    'sustainable industrial policy',
    'sustainable living',
    'sustainable resource management',
    'sustainable tourism',
    'sustainable transport',
    'sustainableuse2005',
    'swimming water',
    'switzerland',
    'swordfish',
    'synthesis',
    'systemic risks',
    'target',
    'tax',
    'tax deduction',
    'taxes',
    'tcm',
    'technological accidents',
    'technological change',
    'technological hazards',
    'technological innovation',
    'technological progress',
    'technologies',
    'technology',
    'teleconference',
    'television',
    'temperature',
    'temperature increase',
    'temperature-sensitive species',
    'template',
    'tender',
    'term',
    'term indicators',
    'term001',
    'term002',
    'term003',
    'term004',
    'term006',
    'term007',
    'term008',
    'term009',
    'term01',
    'term010',
    'term011',
    'term012',
    'term013',
    'term014',
    'term015',
    'term016',
    'term018',
    'term019',
    'term02',
    'term020',
    'term021',
    'term022',
    'term023',
    'term024',
    'term025',
    'term026',
    'term027',
    'term028',
    'term029',
    'term03',
    'term030',
    'term031',
    'term032',
    'term033',
    'term034',
    'term035',
    'term036',
    'term037',
    'term038',
    'term04',
    'term040',
    'term09',
    'term18',
    'term19',
    'term20',
    'term2009',
    'term2010',
    'term2011',
    'term21',
    'term22',
    'term24',
    'term25',
    'term26',
    'term27',
    'term29',
    'term30',
    'term32',
    'term_f02',
    'term_f03',
    'terrestrial',
    'terrestrial ecosystem',
    'territorial',
    'territorial cohesion',
    'territory',
    'textile industry',
    'the risk of carbon leakage',
    'the trading system',
    'thematic assessment',
    'thermophilous deciduous forest',
    'threatened species',
    'threats',
    'threats to biodiversity',
    'tide',
    'tipping element',
    'tipping elements',
    'tire',
    'tire pressure',
    'tobacco',
    'tofp',
    'tourism',
    'tourists',
    'toxic',
    'toxic spills',
    'toxin',
    'tradable carbon unit',
    'tradable permits',
    'trade',
    'trade flows',
    'trading directive',
    'traffic',
    'traffic jam',
    'tram',
    'transboundary issues',
    'transboundary waste shipment',
    'transitional water',
    'transport',
    'transport demand',
    'transport emissions',
    'transport infrastructure',
    'transport noise',
    'transport price',
    'transport subsidies',
    'trawl',
    'trawling',
    'tree',
    'trend',
    'triazine pesticides',
    'tropical night',
    'tropospheric ozone',
    'tsp',
    'tuna',
    'turtle',
    'twitter',
    'uaa',
    'ultrafine particle',
    'umz',
    'un',
    'un climate conference',
    'undernourishment',
    'understanding climate change',
    'undp',
    'unece',
    'unfccc',
    'united states',
    'units',
    'uranium',
    'urban',
    'urban air quality',
    'urban area',
    'urban atlas',
    'urban beekeeping',
    'urban design',
    'urban ecosystem',
    'urban environment',
    'urban forest',
    'urban growth',
    'urban lifestyle',
    'urban morphological zones',
    'urban planning',
    'urban policy',
    'urban population',
    'urban sprawl',
    'urban structure',
    'urban traffic',
    'urban transport',
    'urban waste water',
    'urbanisation',
    'urbanization',
    'usa',
    'use patterns',
    'utm',
    'uv',
    'uv rays',
    'uwwt directive',
    'vector data',
    'vegetable',
    'vegetation',
    'vehicle',
    'vertebrates',
    'veterinary medicines',
    'video',
    'videoconferencing',
    'vineyard',
    'violence',
    'volatile organic compounds',
    'volcanic eruptions',
    'volga',
    'vulnerabilities',
    'war',
    'war of independence',
    'warm',
    'washing machine',
    'waste',
    'waste bioenergy potential',
    'waste disposal',
    'waste export',
    'waste generation',
    'waste import',
    'waste incineration',
    'waste management',
    'waste policies',
    'waste policy',
    'waste prevention',
    'waste recovery',
    'waste water',
    'waste2008',
    'wastewater',
    'wastewater treatment',
    'water',
    'water abstraction',
    'water account',
    'water assessment',
    'water consumption',
    'water data centre',
    'water demand',
    'water engineering project',
    'water exploitation index',
    'water flow',
    'water footprint',
    'water framework directive',
    'water framework directive article 5',
    'water framework directive article 8',
    'water information system for europe',
    'water legislation',
    'water level',
    'water loss',
    'water management',
    'water pollution',
    'water pollution from agriculture',
    'water protection',
    'water protection directive',
    'water quality',
    'water quantity',
    'water resource management',
    'water resources',
    'water scarcity',
    'water security',
    'water services',
    'water shortage',
    'water supply',
    'water temperature',
    'water towers',
    'water transport',
    'water use',
    'water watch',
    'water-borne diseases',
    'waterbase',
    'waterway',
    'wb2009',
    'web tool',
    'wec',
    'wec005',
    'wec04e',
    'wec07b',
    'wec2d',
    'wei',
    'welfare',
    'welfare change',
    'well-being',
    'wells',
    'western balkans',
    'wetland',
    'weu',
    'weu001',
    'weu002',
    'weu003',
    'weu004',
    'weu005',
    'weu007',
    'weu008',
    'weu009',
    'weu010',
    'weu011',
    'weu013',
    'weu014',
    'weu015',
    'weu016',
    'wfd',
    'what we do',
    'white goods',
    'white-backed woodpecker',
    'who',
    'who we are',
    'whs',
    'whs002',
    'whs003',
    'whs007',
    'whs008',
    'whs009',
    'whs010',
    'whs011',
    'whs012',
    'whs01a',
    'whs6_whs7',
    'wilderness',
    'wildlife',
    'wind',
    'wind energy',
    'wind energy potential',
    'wind speed',
    'windbreak',
    'windmill',
    'windstorms',
    'wine',
    'winter sport',
    'wir3',
    'wise',
    'wise state of the environment(soe)',
    'wolf',
    'wood',
    'wood supply',
    'working area',
    'working remit',
    'world',
    'world health organisation',
    'wq',
    'wq002',
    'wq004',
    'wq005',
    'wq006',
    'wq01c',
    'wq02a',
    'wq02e',
    'wq03b',
    'wrapping',
    'wwf',
    'yearbook',
    'youth audience',
    'youtube',
    'zone',
])

import logging
import transaction
from zope.component.hooks import getSite
from Products.CMFCore.utils import getToolByName
logger = logging.getLogger('Products.EEAPloneAdmin')

def _fixUnicodeKeywords(brain, catalog):
    """ Fix unicode keywords
    """
    try:
        doc = brain.getObject()
    except AttributeError:
        logger.warn('Uncatalog broken brain %s', brain.getURL())
        catalog.uncatalog_object(catalog.getpath(brain.data_record_id_))
        return
    else:
        doc.reindexObject(idxs=['Subject'])
        return doc

def fixUnicodeKeywords(self):
    """ Fix unicode keywords
    """
    site = getSite()
    catalog = getToolByName(site, 'portal_catalog')

    tags = catalog.Indexes.get('Subject').uniqueValues()
    tags = [tag for tag in tags if isinstance(tag, unicode)]

    brains = catalog(Subject={'query': tags, 'operator': 'or'},
                     Language='all', showInactive=True)
    total = len(brains)

    logger.info('Fixing unicode keywords for %s documents...', total)

    step = 1
    for index, brain in enumerate(brains):
        try:
            fixed = _fixUnicodeKeywords(brain, catalog)
        except Exception as err:
            logger.warn("ERROR: %s", brain.getURL())
            logger.exception(err)
            continue

        if not fixed:
            continue

        step += 1
        if step % 100 == 0:
            logger.info('Fixing keywords...%s/%s', index, total)
            transaction.commit()

    msg = "Fixing unicode keywords for %s documents... DONE" % total
    logger.info(msg)
    return msg

def _fixKeywords(brain, catalog):
    """ Fix keywords
    """
    try:
        doc = brain.getObject()
    except AttributeError:
        logger.warn('Uncatalog broken brain %s', brain.getURL())
        catalog.uncatalog_object(catalog.getpath(brain.data_record_id_))
        return

    canonical = doc.getCanonical()
    original = canonical.getField('subject').getAccessor(canonical)()
    original = [tag for tag in original if tag.lower() in allowed]

    mine = set(brain.Subject)
    if set(mine).symmetric_difference(original):
        doc.getField('subject').getMutator(doc)(original)
        doc.reindexObject(idxs=['Subject'])
        return doc
    return None

def fixKeywords(self):
    """ Fix language independent keywords
    """
    site = getSite()
    catalog = getToolByName(site, 'portal_catalog')

    tags = catalog.Indexes.get('Subject').uniqueValues()
    tags = [tag for tag in tags if tag.lower() not in allowed]

    brains = catalog(Subject={'query': tags, 'operator': 'or'},
                     Language='all', showInactive=True)
    total = len(brains)

    logger.info('Fixing keywords for %s documents...', total)

    step = 1
    for index, brain in enumerate(brains):
        try:
            fixed = _fixKeywords(brain, catalog)
        except Exception as err:
            logger.warn("ERROR: %s", brain.getURL())
            logger.exception(err)
            continue

        if not fixed:
            continue

        step += 1
        if step % 100 == 0:
            logger.info('Fixing keywords...%s/%s', index, total)
            transaction.commit()

    msg = "Fixing keywords for %s documents... DONE" % total
    logger.info(msg)
    return msg

def fixRussianKeywords(self):
    """ Fix Russian keywords
    """
    site = getSite()
    catalog = getToolByName(site, 'portal_catalog')

    subject = catalog.Indexes.get('Subject')
    tags = subject.uniqueValues()
    tags = [tag for tag in tags if tag.lower() not in allowed]

    brains = catalog(Subject={'query': tags, 'operator': 'or'},
                     Language='all', showInactive=True)
    total = len(brains)

    logger.info('Fixing keywords for %s documents...', total)
    for brain in brains:
        logger.info('Reindex object %s', brain.getURL())
        doc = brain.getObject()
        doc.reindexObject(idxs=['Subject'])

        logger.info('Forcing index cleanup of tags %s', tags)
        subject.unindex_objectKeywords(brain.data_record_id_, tags)

    msg = "Fixing keywords for %s documents... DONE" % total
    logger.info(msg)
    return msg
